using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.ApplicationBlocks.Data;
using System.Collections;
using System.Data.SqlClient;

/// <summary>
/// Summary description for DBActions
/// </summary>
public class DALActions
{
    private static SqlConnection cn;
    private static SqlCommand cmd;
    private static SqlDataAdapter da;
    private static SqlCommandBuilder cmdb;
    private static SqlDataReader dr;
    private static DataSet ds;

    static DALActions()
    {
        try
        {
            cn = null;
            cmd = null;
            da = null;
            ds = null;
            cmdb = null;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
    }

    public static DataSet getdatabaserecord(string cnnstring, string sq, string tname)
    {
        try
        {
            da = new SqlDataAdapter(sq, cnnstring);
            cmdb = new SqlCommandBuilder(da);
            ds = new DataSet();
            da.Fill(ds, tname);
            return ds;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
    }

    public static void RunSqlCommmand(string ConStr, string ProcName, SqlParameter[] p)
    {
        try
        {
            cn = new SqlConnection(ConStr);
            cn.Open();
            cmd = new SqlCommand(ProcName, cn);
            cmd.CommandType = CommandType.StoredProcedure;
            foreach (SqlParameter p1 in p)
            {
                if (p1 != null)
                    cmd.Parameters.Add(p1);
            }
            cmd.ExecuteNonQuery();
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
        finally
        {
            if (cn != null)
                if (cn.State == ConnectionState.Open)
                    cn.Close();
        }
    }

    public static string RunSqlCommmand1(string ConStr, string ProcName, SqlParameter[] p)
    {
        string str;
        try
        {
            cn = new SqlConnection(ConStr);
            cn.Open();
            cmd = new SqlCommand(ProcName, cn);
            cmd.CommandType = CommandType.StoredProcedure;
            foreach (SqlParameter p1 in p)
            {
                if (p1 != null)
                    cmd.Parameters.Add(p1);
            }
            cmd.ExecuteNonQuery();
            str = Convert.ToString(cmd.Parameters[4].Value.ToString());
            return str;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
        finally
        {
            if (cn != null)
                if (cn.State == ConnectionState.Open)
                    cn.Close();
        }
    }

    public static void updatedatasset(DataSet ds, string tname)
    {
        try
        {
            da.Update(ds, tname);
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
    }

    //  public static void SaveCust_Info(string ConStr, string ProcName, SqlParameter[] param)
    //{

    //   cn = new SqlConnection(ConStr);
    // cn.Open();
    // cmd = new SqlCommand(ProcName, cn);
    // cmd.CommandType = CommandType.StoredProcedure;
    // try
    // {
    // foreach (SqlParameter p1 in param) 
    //  {
    //    if (p1 != null)
    // {
    //        cmd.Parameters.Add(p1);
    // }
    //}
    //  cmd.ExecuteNonQuery();
    // }
    //   catch(SqlException ex)
    //    {
    //       throw new ArgumentException(ex.Message);
    //  }
    //  catch(Exception ex)
    //   {
    //      throw new ArgumentException(ex.Message);
    //}
    // finally
    // {
    //   if(cn!=null)
    //   {
    //      if (cn.State == ConnectionState.Open) 
    //     {
    //        cn.Close();
    //    }
    // }    
    //  }

    //  }
    //public static void SaveCust_add_Info(string ConStr, string ProcName, SqlParameter[] param)
    //{

    //    cn = new SqlConnection(ConStr);
    //    cn.Open();
    //    cmd = new SqlCommand(ProcName, cn);
    //    cmd.CommandType = CommandType.StoredProcedure;
    //    try
    //    {
    //        foreach (SqlParameter p2 in param)
    //        {
    //            if (p2 != null)
    //            {
    //                cmd.Parameters.Add(p2);
    //            }
    //        }
    //        cmd.ExecuteNonQuery();
    //    }
    //    catch (SqlException ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    catch (Exception ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    finally
    //    {
    //        if (cn != null)
    //        {
    //            if (cn.State == ConnectionState.Open)
    //            {
    //                cn.Close();
    //            }
    //        }
    //    }

    //}
    //public static void SaveVehicle_Info(string ConStr, string ProcName, SqlParameter[] param)
    //{

    //    cn = new SqlConnection(ConStr);
    //    cn.Open();
    //    cmd = new SqlCommand(ProcName, cn);
    //    cmd.CommandType = CommandType.StoredProcedure;
    //    try
    //    {
    //        foreach (SqlParameter p3 in param)
    //        {
    //            if (p3 != null)
    //            {
    //                cmd.Parameters.Add(p3);
    //            }
    //        }
    //        cmd.ExecuteNonQuery();
    //    }
    //    catch (SqlException ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    catch (Exception ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    finally
    //    {
    //        if (cn != null)
    //        {
    //            if (cn.State == ConnectionState.Open)
    //            {
    //                cn.Close();
    //            }
    //        }
    //    }
    //}

    public static string getStringValue(string ConStr, string ProcName, SqlParameter[] param)
    {
        string strval;
        cn = new SqlConnection(ConStr);
        cn.Open();
        cmd = new SqlCommand(ProcName, cn);
        cmd.CommandType = CommandType.StoredProcedure;
        try
        {
            foreach (SqlParameter p in param)
            {
                if (p != null)
                {
                    cmd.Parameters.Add(p);
                }
            }
            //strval = int.Parse(cmd.ExecuteReader());
            strval = Convert.ToString(cmd.ExecuteScalar());
            return strval;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
        finally
        {
            if (cn != null)
            {
                if (cn.State == ConnectionState.Open)
                {
                    cn.Close();
                }
            }
        }
    }

    public static SqlDataReader getIntValue(string ConStr, string ProcName)
    {
        try
        {
            cn = new SqlConnection(ConStr);
            cn.Open();
            cmd = new SqlCommand(ProcName, cn);
            //cmd.CommandType = CommandType.StoredProcedure;
            //try
            //{
            //    foreach (SqlParameter p in param)
            //    {
            //        if (p != null)
            //        {
            //            cmd.Parameters.Add(p);
            //        }

            //    }
            dr = cmd.ExecuteReader();
            if (dr.Read())
            {
                return dr;
            }
            return dr;
            //Convert.ToString(cmd.ExecuteScalar());
            // cmd.ExecuteNonQuery();
            //   return strval;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
        //finally
        //{
        //    if (cn != null)
        //    {
        //        if (cn.State == ConnectionState.Open)
        //        {
        //            cn.Close();
        //        }
        //    }
        //}
    }
    public static SqlDataReader GetData(string ConStr, string ProcName, SqlParameter[] param)
    {
        SqlDataReader dr;
        cn = new SqlConnection(ConStr);
        cn.Open();
        cmd = new SqlCommand(ProcName, cn);
        cmd.CommandType = CommandType.StoredProcedure;
        try
        {
            foreach (SqlParameter p1 in param)
            {
                if (p1 != null)
                {
                    cmd.Parameters.Add(p1);
                }

            }
            dr = cmd.ExecuteReader();
            return dr;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {
            throw new ArgumentException(ex.Message);
        }
        //finally
        //{
        //    if (cn != null)
        //    {
        //        if (cn.State == ConnectionState.Open)
        //        {
        //            cn.Close();
        //        }
        //    }
        //}
    }
    public static DataSet GetVehInfo(string sq, string tname, SqlParameter[] param)
    {
        try
        {
            cn = new SqlConnection(sq);
            cmd = new SqlCommand(sq, cn);
            cmd.CommandType = CommandType.StoredProcedure;
            foreach (SqlParameter p in param)
            {
                if (p != null)
                {
                    cmd.Parameters.Add(p);
                }
            }
            da = new SqlDataAdapter(tname, sq);
            cmdb = new SqlCommandBuilder(da);
            ds = new DataSet();
            da.Fill(ds, tname);
            return ds;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        catch (Exception ex)
        {            
            throw new ArgumentException(ex.Message);
        }
    }
    //public static DataSet execdataset(string ConStr, string ProcName, SqlParameter[] param)
    //{
    //    //string strval;

    //    cn = new SqlConnection(ConStr);
    //    cn.Open();
    //    DataSet ds;
    //     ds = new DataSet();

    //     da = new SqlDataAdapter(ProcName , cn);
    //    //SqlDataReader dr;
    // //   cmd = new SqlCommand(ProcName, cn);
    //   // da.CommandType = CommandType.StoredProcedure;
    //    try
    //    {
    //        foreach (SqlParameter p1 in param)
    //        {
    //            if (p1 != null)
    //            {
    //                cmd.Parameters.Add(p1);
    //            }

    //        }
    //        //ds =(DataSet)cmd.ExecuteReader();
    //        da.Fill(ds,"s");
    //        //if (ds.Read())
    //        //{
    //        //    return ds;
    //        //}
    //        return ds;

    //da = new SqlDataAdapter(sq, cnnstring);
    //cmdb = new SqlCommandBuilder(da);
    //ds = new DataSet();
    //da.Fill(ds, tname);
    //return ds;
    //dr = cmd.ExecuteReader();
    //Convert.ToString(cmd.ExecuteScalar());
    // cmd.ExecuteNonQuery();
    //return dr;
    //    }
    //    catch (SqlException ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    catch (Exception ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    finally
    //    {
    //        if (cn != null)
    //        {
    //            if (cn.State == ConnectionState.Open)
    //            {
    //                cn.Close();
    //            }
    //        }
    //  }
    //}

    public static DataSet execdataset_get(string ConStr, string str1, string tname)
    {
        try
        {
            cn = new SqlConnection(ConStr);
            cn.Open();
            DataSet ds;
            ds = new DataSet();
            // cmd = new SqlCommand(str1);
            da = new SqlDataAdapter(str1, cn);
            da.Fill(ds, tname);
            return ds;
        }
        catch (SqlException ex)
        {
            throw new ArgumentException(ex.Message);
        }
        finally
        {
            if (cn != null)
            {
                if (cn.State == ConnectionState.Open)
                {
                    cn.Close();
                }
            }
        }
    }
    //public static getStringValue_getdata(string ConStr, string ProcName, SqlParameter[] param)
    //{
    //    // string strval;
    //    registration obj = new registration();
    //    cn = new SqlConnection(ConStr);
    //    cn.Open();
    //    cmd = new SqlCommand(ProcName, cn);
    //    cmd.CommandType = CommandType.StoredProcedure;
    //    try
    //    {
    //        foreach (SqlParameter p in param)
    //        {
    //            if (p != null)
    //            {
    //                cmd.Parameters.Add(p);
    //            }

    //        }
    //        cmd.ExecuteNonQuery();
    //        obj.Veh_no = cmd.Parameters[0].Value.ToString();
    //        obj.Veh_type = cmd.Parameters[1].Value.ToString();
    //        obj.Veh_model = cmd.Parameters[2].Value.ToString();
    //        obj.On_road_cost1 = cmd.Parameters[4].Value.ToString();
    //        obj.Show_r_cost = cmd.Parameters[3].Value.ToString();

    //        // strval = int.Parse(cmd.ExecuteReader());
    //        // strval=Convert.ToString(cmd.ExecuteReader ());
    //        return obj;
    //    }
    //    catch (SqlException ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    catch (Exception ex)
    //    {
    //        throw new ArgumentException(ex.Message);
    //    }
    //    finally
    //    {
    //        if (cn != null)
    //        {
    //            if (cn.State == ConnectionState.Open)
    //            {
    //                cn.Close();
    //            }
    //        }
    //    }

    //}
}